'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = process;

var _preprocess = require('./preprocess');

var _preprocess2 = _interopRequireDefault(_preprocess);

var _printer = require('./printer');

var _printer2 = _interopRequireDefault(_printer);

var _convertBindAttr = require('./formulas/convert-bind-attr');

var _convertBindAttr2 = _interopRequireDefault(_convertBindAttr);

var _convertEachIn = require('./formulas/convert-each-in');

var _convertEachIn2 = _interopRequireDefault(_convertEachIn);

var _whitespace = require('../lib/whitespace');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var plugins = {
  'convert-bind-attr': _convertBindAttr2.default,
  'convert-each-in': _convertEachIn2.default
};

function getPlugins(formulas) {
  return (formulas || []).map(function (f) {
    return plugins[f];
  });
}

function transform(ast, formulas) {
  var usedPlugins = getPlugins(formulas);
  usedPlugins.forEach(function (p) {
    return p(ast);
  });
  return ast;
}

function process(template) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var ast = (0, _preprocess2.default)(template);
  transform(ast, options.formulas);
  return (0, _whitespace.unescape)((0, _printer2.default)(ast, options));
}