'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = fixAttrMustacheLoc;

var _glimmerSyntax = require('glimmer-engine/dist/node_modules/glimmer-syntax');

/* eslint no-param-reassign: [0, { "ignorePropertyModificationsFor": ["attr"] }] */
function fixAttrMustacheLoc(ast) {
  var walker = new _glimmerSyntax.Walker(ast);

  walker.visit(ast, function (node) {
    if (node.type === 'ElementNode') {
      node.attributes.forEach(function (attr) {
        var attrLoc = attr.loc;
        var attrStart = attrLoc.start;
        var attrEnd = attrLoc.end;
        var valueLoc = attr.value.loc;
        var line = attrStart.line;
        //     attr="value"
        //     ^  ^^ +1   ^
        // start  length  end
        var column = attrStart.column + attr.name.length + 1;
        if (!valueLoc) {
          valueLoc = _glimmerSyntax.builders.loc(line, column, attrEnd.line, attrEnd.column);
        } else if (valueLoc.start.line === null || valueLoc.start.column === null) {
          valueLoc.start.line = line;
          valueLoc.start.column = column;
        }
        attr.value.loc = valueLoc;
      });
    }
  });

  return ast;
}