'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = escapeHTML;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var chars = {
  '&': '&amp;',
  '<': '&lt;',
  '>': '&gt;',
  '"': '&quot;',
  "'": '&#39;',
  '\xA0': '&nbsp;',
  '×': '&times;'
};

var regex = new RegExp('(' + (0, _keys2.default)(chars).join('|') + ')', ['g']);

function escapeHTML(str) {
  return str.replace(regex, function (c) {
    return chars[c];
  });
}